// 005 u_find_memo
// 12 jun 2005

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_bfs_select_win32;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, StdCtrls, ExtCtrls, ComCtrls, FMTBcd, Grids, DBGrids,
  DB, DBClient, Provider, SqlExpr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    Splitter2: TSplitter;
    SQLConnection1: TSQLConnection;
    SQLDataSet1: TSQLDataSet;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    Panel5: TPanel;
    prepare_: TButton;
    execute_: TButton;
    days_edit_: TEdit;
    PageControl1: TPageControl;
    select_all_: TTabSheet;
    DBGrid1: TDBGrid;
    parametrized_: TTabSheet;
    DBGrid2: TDBGrid;
    SQLDataSet2: TSQLDataSet;
    DataSetProvider2: TDataSetProvider;
    ClientDataSet2: TClientDataSet;
    DataSource2: TDataSource;
    days_min: TLabel;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure prepare_Click(Sender: TObject);
    procedure execute_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_c_display
  ;

{$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- parametrized queries

    const k_parametrized_select=
              'SELECT c_id, c_course_name, c_days '
            + '  FROM COURSE'
            + '  WHERE '
            + '    (c_days >= ?)';

    var g_c_parameter: tParam;
            
    procedure TForm1.prepare_Click(Sender: TObject);
      begin
        display('> prepare');
        PageControl1.ActivePage:= parametrized_;
        ClientDataSet2.Close;
        SqlConnection1.Open;


        with SqlDataset2 do
        begin
          Close;
          CommandText:= k_parametrized_select;

          Params.Clear;

          g_c_parameter:= Params.CreateParam(ftInteger, 'c_days', ptInput);

          // no Prepare;
          // no PrepareStatement;
        end; // with SqlQuery1
        display('< prepare');
      end; // prepare_Click

    procedure TForm1.execute_Click(Sender: TObject);
      begin
        ClientDataSet2.Close;
        g_c_parameter.Value:= StrToInt(days_edit_.Text);
        ClientDataSet2.Open;
      end; // execute_Click

end.
